%% Author: Thomas Möllenhoff
% Generate a "3-moon" dataset.
function [X,y,actualN] = make3moons(Ntotal, variance, dim)
    N = floor(Ntotal/3);
    theta = rand(N,3)*(pi);

    X1=[cos(theta(:,1)) sin(theta(:,1))];
    X2=[3+cos(theta(:,2)) sin(theta(:,2))];
    X3=[1.5+1.5*cos(theta(:,3)) 0.4-1.5*sin(theta(:,3))];

    X=zeros(3*N, dim);
    X(1:N, 1:2) = X1;
    X(N+1:2*N, 1:2) = X2;
    X(2*N+1:3*N, 1:2) = X3;
    X = X + variance*randn(3*N, dim);

    y=zeros(3*N,1);
    y(1:N) = 1;
    y(N+1:2*N) = 2;
    y(2*N+1:3*N) = 3;
    
    shuffle = randsample(3*N,3*N);
    
    X=X(shuffle,:);
    y=y(shuffle,:);

    actualN = N*3;
end
