clc;
close;
clear;

%% Generate data
[X, y, n] = make3moons(2500, sqrt(0.02), 100);
k = max(y(:));
classes = y;
NN = 8; % number of nearest neighbours to consider
M = 17; % local scale parameter
A = create_graph_zmp(X, NN, M, 'avg');
num_vertices = size(A, 1);
num_edges = sum(sum(double(A>0)))/2;
D = adj_to_gradient(A,num_vertices,num_edges);

%% distribute labels 
percent_labeled = 5;
fweights = 10;

num_labeled = max(1, round((percent_labeled/(100*k)) * num_vertices));
for l=1:k
    indices = find(classes == l);
    prev_indices = indices;
    idx = (l-1)*num_labeled;
    idx_label(idx+1:idx+num_labeled) = indices(1:num_labeled);
end
num_labeled = num_labeled * k;
idx_label = idx_label(1:num_labeled)';

% show the original input. gray points is unlabeld, red ones are labeled.
figure(1)
hold on;
title('labeled data');
plot(X(:,1),X(:,2),'o','color', [211,211,211]/255);
plot(X(idx_label,1),X(idx_label,2),'or');

%% TODO: construct f. 
%        idx_label gives you the index of labeled points.
%        classes gives you the label of each points (ground truth).


f = f * fweights;
 

%% initialize general parameters
max_iters=1500;


%% TODO: Implement ADMM or PDHG to solve the problem.
%        Please save your results in u. u should be the size of n*k
%        This time you don't need to consider duality gap.
%        Just do a for-loop.


%% Show Results
[~,results] = max(u,[],2);
figure(2)
hold on;
strings = ['or','ob','og'];
for i = 1:k
    index = find(results==i);
    plot(X(index,1),X(index,2),strings(2*i-1:2*i));
end
fprintf('accuracy:%.4f\n (should be around 0.98)', sum(double(results-y==0))/n);